package com.fr.plugin.theme.ngx;

import com.fr.decision.config.AppearanceConfig;
import com.fr.web.struct.Component;
import com.fr.web.struct.category.ScriptPath;
import com.fr.web.struct.category.StylePath;
import com.fr.web.struct.Filter;

/**
 * Created by Zed on 2018/10/12.
 */
public class NgxComponent extends Component {

    public static final NgxComponent KEY = new NgxComponent();

    private NgxComponent() {

    }

    @Override
    public ScriptPath script() {
        return ScriptPath.build("com/fr/plugin/theme/ngx/web/theme.js");
    }

    @Override
    public StylePath style() {
        return StylePath.build("com/fr/plugin/theme/ngx/web/style.css");
    }

    @Override
    public Filter filter() {
        return new Filter() {
            public boolean accept() {
                return "com.fr.plugin.decision.theme.ngx".equals(AppearanceConfig.getInstance().getThemeId());
            }
        };
    }
}