/**
 *@desc 自定义的header
 *@author dailer
 *@date 2018/12/25
 */
!(function () {
    var Widget = BI.inherit(BI.Widget, {

        props: {
            baseCls: "demo-favorite"
        },

        beforeInit: function (render) {
            var self = this;
            Dec.Utils.getFavoritesList(function (res) {
                self.items = res.data;
                render();
            });
        },

        render: function () {
            var self = this;

            var trigger = {
                type: "bi.icon_button",
                cls: "favorite-font",
                handler: function () {

                }
            };

            var popup = {
                type: "bi.button_group",
                layouts: [
                    {
                        type: "bi.vertical",
                        vgap: 5
                    }
                ],
                ref: function (_ref) {
                    self.popup = _ref;
                },
                items: this._createItems()
            };

            return {
                type: "bi.combo",
                trigger: "click-hover",
                el: trigger,
                popup: {
                    el: popup,
                    cls: "demo-background",
                    minWidth: 200
                }
            };
        },

        _createItems: function () {
            var self = this;
            return BI.map(this.items, function (index, item) {
                return BI.extend(item, {
                    type: "dec.workbench.panel.favorite.item",
                    closeable: true,
                    onClose: function () {
                        self._unFavorite(item.id);
                    },
                    handler: function () {
                        self._openFavorite(item);
                    }
                });
            });
        },

        _openFavorite: function (item) {
            BI.Services.getService("dec.service.tabs").addItem(item);
        },

        _unFavorite: function (id) {
            this.items = BI.filter(this.items, function (index, fav) {
                return fav.id !== id;
            });
            this.popup.populate(this._createItems());
            Dec.Utils.handlerCollect(id, false, BI.emptyFn);
        }
    });

    BI.shortcut("demo.favorite", Widget);
}());