!(function () {
    var Node = BI.inherit(BI.BasicButton, {

        props: {
            baseCls: "demo-sidebar-expander",
            items: [],
            open: false
        },

        render: function () {

            var self = this, o = this.options;


            var trigger = {
                type: "demo.sidebar.node",
                text: o.text,
                height: 42,
                open: o.open,
                iconCls: o.nodeIcon,
                listeners: [
                    {
                        eventName: "EVENT_EXPAND",
                        action: function () {
                            self.showView();
                        }
                    }, {
                        eventName: "EVENT_COLLAPSE",
                        action: function () {
                            self.popuop.setVisible(false);
                        }
                    }
                ]
            };

            var items = BI.createItems(o.items, {
                type: "demo.sidebar.item",
                lgap: 30,
                height: 36
            });
            return {
                type: "bi.vertical",
                items: [
                    {
                        el: trigger
                    }, {
                        el: {
                            type: "bi.button_group",
                            cls: "demo-sidebar-expander-popup",
                            layouts: [
                                {
                                    type: "bi.vertical"
                                }
                            ],
                            ref: function (_ref) {
                                self.popuop = _ref;
                            },
                            invisible: !o.open,
                            items: items
                        }
                    }
                ]

            };
        },

        showView: function () {
            var self = this, o = this.options;
            if (BI.isEmptyArray(o.items)) {
                Dec.Utils.getWorkbenchSubDirectoryById(o.id, function (res) {
                    o.items = BI.map(res.data, function (index, item) {
                        return BI.extend({
                            type: "demo.sidebar.item",
                            lgap: 30
                        }, item);
                    });
                    self.popuop.populate(o.items);
                    self.popuop.setVisible(true);
                });
            } else {
                self.popuop.setVisible(true);
            }
        }
    });

    BI.shortcut("demo.sidebar.expander", Node);
}());