!(function () {
    var itemStorage = {};

    Dec.inactiveOthers = function (id) {
        BI.each(itemStorage, function (key, widget) {
            widget.options.id !== id && widget.setSelected(false);
        });
    };

    var Node = BI.inherit(BI.BasicButton, {

        props: {
            baseCls: "demo-sidebar-item",
            id: "",
            pId: "",
            open: false,
            height: 35,
            iconCls: "dir-panel-folder-font"
        },

        mounted: function () {
            itemStorage[this.options.id] = this;
        },

        render: function () {

            var self = this, o = this.options;


            var text = {
                type: "bi.label",
                height: o.height,
                textAlign: "left",
                text: o.text,
                title: o.text
            };

            var items = [];

            items.push({
                el: text,
                height: o.height
            });
            return {
                type: "bi.vertical_adapt",
                lgap: o.lgap,
                items: [
                    {
                        type: "bi.label",
                        textAlign: "left",
                        text: o.text,
                        title: o.text
                    }
                ]
            };
        },

        isOnce: function () {
            return true;
        },

        getValue: function () {
            return this.options.id;
        },

        doClick: function () {
            var self = this;
            Dec.inactiveOthers(this.options.id);
            var module = BI.find(BI.Constants.getConstant("dec.constant.management.navigation"), function (index, item) {
                return item.value === self.options.id;
            });
            if (module) {
                BI.Services.getService("dec.service.tabs").addItem(module);
            } else {
                BI.Services.getService("dec.service.tabs").addItem(BI.deepClone(this.options));
            }
        }
    });

    BI.shortcut("demo.sidebar.item", Node);
}());