/**
 *@desc 自定义的sidebar
 *@author dailer
 *@date 2018/12/25
 */
!(function () {
    var Widget = BI.inherit(BI.Widget, {

        props: {
            baseCls: "demo-sidebar"
        },

        /**
         *  初始化目录根节点和管理系统节点
         */
        beforeInit: function (render) {
            var self = this;
            this._initManagementModules(BI.emptyFn);
            this._initEntries(render);
        },

        render: function () {
            var items = [];
            items.push({
                el: {
                    type: "demo.sidebar.item",
                    cardType: "dec.dashboard",
                    text: "仪表板",
                    lgap: 10
                }
            });
            items.push({
                el: {
                    type: "bi.label",
                    textAlign: "left",
                    lgap: 10,
                    height: 46,
                    text: "目录"
                }
            });
            items = BI.concat(items, this.rootEntries);
            items.push({
                type: "demo.sidebar.expander",
                text: "管理系统",
                open: true,
                items: this.managementModules
            });
            return {
                type: "bi.absolute",
                items: [
                    {
                        el: {
                            type: "bi.vertical",
                            items: items
                        },
                        top: 10, left: 0, right: 0, bottom: 0
                    }
                ]

            };
        },

        _initEntries: function (cb) {
            var self = this;
            Dec.Utils.getWorkbenchSubDirectoryById(DecCst.DIRECTORY_TREE_ROOT_ID, function (res) {
                self.rootEntries = BI.map(res.data, function (index, item) {
                    return BI.extend({
                        type: "demo.sidebar.expander",
                        items: item.children
                    }, item);
                });
                cb();
            });
        },

        _initManagementModules: function (cb) {
            this.managementModules = BI.filter(BI.Constants.getConstant("dec.constant.management.navigation"), function (index, item) {
                return item.id !== "decision-management-maintenance";
            });
            cb();
        }
    });

    BI.shortcut("demo.sidebar", Widget);
}());