!(function () {
    var Node = BI.inherit(BI.NodeButton, {

        props: {
            baseCls: "demo-sidebar-node",
            id: "",
            pId: "",
            open: false,
            height: 42,
            iconCls: "dir-panel-folder-font"
        },

        render: function () {

            var self = this, o = this.options;

            var arrow = {
                type: "bi.center_adapt",
                cls: "platform-node-arrow",
                items: [
                    {
                        el: {
                            type: "bi.icon_change_button",
                            ref: function (_ref) {
                                self.arrow = _ref;
                            },
                            iconCls: o.open ? "triangle-expand-font" : "triangle-collapse-font",
                            height: 16,
                            width: 16
                        }
                    }
                ]
            };

            var icon = {
                type: "bi.center_adapt",
                height: o.height,
                cls: "platform-node-icon " + o.iconCls,
                items: [
                    {
                        type: "bi.icon",
                        height: o.height,
                        width: o.height
                    }
                ]
            };

            var text = {
                type: "bi.htape",
                height: o.height,
                items: [
                    {
                        el: {
                            type: "bi.label",
                            height: o.height,
                            textAlign: "left",
                            text: o.text
                        },
                        lgap: 5
                    }
                ]
            };

            var items = [];
            items.push({
                type: "bi.layout",
                width: 10,
                height: o.height
            });

            items.push({
                el: icon,
                height: o.height,
                width: o.height
            });

            items.push({
                el: text,
                height: o.height
            });
            items.push({
                el: arrow,
                height: o.height,
                width: 16,
                rgap: 10
            });

            return {
                type: "bi.htape",
                items: items
            };
        },

        isOnce: function () {
            return false;
        },

        getValue: function () {
            return this.options.id;
        },

        setOpened: function (v) {
            Node.superclass.setOpened.apply(this, arguments);
            this.arrow.setIcon(v ? "triangle-expand-font" : "triangle-collapse-font");
            this.fireEvent(v ? "EVENT_EXPAND" : "EVENT_COLLAPSE");
        }
    });

    BI.shortcut("demo.sidebar.node", Node);
}());