/**
 *@desc 自定义的header
 *@author dailer
 *@date 2018/12/25
 */
!(function () {
    BI.config("dec.header", function (config) {
        config.type = "demo.header";
        return config;
    });

    BI.config("dec.provider.layout", function (provider) {
        provider.setConfig({
            type: "bi.absolute",
            cls: "demo-background",
            items: [
                {
                    el: {
                        type: "bi.absolute",
                        items: [
                            {
                                el: {
                                    type: "dec.workbench.tabs",
                                    cls: "bi-background",
                                    showTabBar: false
                                },
                                top: 0, bottom: 20, right: 20,
                                left: 260
                            }, {
                                el: {
                                    type: "demo.sidebar",
                                    width: 240
                                },
                                top: 0, bottom: 0,
                                left: 0
                            }
                        ]
                    },
                    top: 70, left: 0, right: 0, bottom: 0
                }, {
                    el: {
                        type: "dec.header"
                    },
                    height: 50,
                    top: 0, left: 0, right: 0
                }
            ]
        });
        return provider;
    });
}());
/**
 *@desc 自定义的header
 *@author dailer
 *@date 2018/12/25
 */
!(function () {
    var Widget = BI.inherit(BI.Widget, {

        props: {
            baseCls: ""
        },

        render: function () {
            return {
                type: "bi.left_right_vertical_adapt",
                items: {
                    left: [
                        {
                            el: {
                                type: "bi.icon_button",
                                width: 30,
                                height: 30
                            }
                        }, {
                            el: {
                                type: "bi.label",
                                textAlign: "left",
                                cls: "title-text",
                                text: "ngx-admin"
                            }
                        }
                    ],
                    right: [
                        {
                            el: {
                                type: "bi.icon_button",
                                width: 30,
                                height: 30
                            }
                        }, {
                            el: {
                                type: "dec.header.message"
                            }
                        }, {
                            el: {
                                type: "dec.account"
                            }
                        }
                    ]
                }
            };
        }
    });

    BI.shortcut("demo.head11er", Widget);
}());
/**
 *@desc 自定义的header
 *@author dailer
 *@date 2018/12/25
 */
!(function () {
    var Widget = BI.inherit(BI.Widget, {

        props: {
            baseCls: "demo-favorite"
        },

        beforeInit: function (render) {
            var self = this;
            Dec.Utils.getFavoritesList(function (res) {
                self.items = res.data;
                render();
            });
        },

        render: function () {
            var self = this;

            var trigger = {
                type: "bi.icon_button",
                cls: "favorite-font",
                handler: function () {

                }
            };

            var popup = {
                type: "bi.button_group",
                layouts: [
                    {
                        type: "bi.vertical",
                        vgap: 5
                    }
                ],
                ref: function (_ref) {
                    self.popup = _ref;
                },
                items: this._createItems()
            };

            return {
                type: "bi.combo",
                trigger: "click-hover",
                el: trigger,
                popup: {
                    el: popup,
                    cls: "demo-background",
                    minWidth: 200
                }
            };
        },

        _createItems: function () {
            var self = this;
            return BI.map(this.items, function (index, item) {
                return BI.extend(item, {
                    type: "dec.workbench.panel.favorite.item",
                    closeable: true,
                    onClose: function () {
                        self._unFavorite(item.id);
                    },
                    handler: function () {
                        self._openFavorite(item);
                    }
                });
            });
        },

        _openFavorite: function (item) {
            BI.Services.getService("dec.service.tabs").addItem(item);
        },

        _unFavorite: function (id) {
            this.items = BI.filter(this.items, function (index, fav) {
                return fav.id !== id;
            });
            this.popup.populate(this._createItems());
            Dec.Utils.handlerCollect(id, false, BI.emptyFn);
        }
    });

    BI.shortcut("demo.favorite", Widget);
}());
/**
 *@desc 自定义的header
 *@author dailer
 *@date 2018/12/25
 */
!(function () {
    var Widget = BI.inherit(BI.Widget, {

        props: {
            baseCls: "demo-header"
        },

        render: function () {
            return {
                type: "bi.left_right_vertical_adapt",
                items: {
                    left: [
                        {
                            el: {
                                type: "bi.icon_button",
                                cls: "directory-font demo-sidebar-trigger",
                                width: 80,
                                height: 35
                            }
                        }, {
                            el: {
                                type: "bi.text_button",
                                textAlign: "left",
                                cls: "demo-title-text",
                                text: "ngx-admin",
                                handler: function () {
                                    BI.Services.getService("dec.service.tabs").openTab(-1);
                                    Dec.inactiveOthers(-1);
                                }
                            }
                        }
                    ],
                    right: [
                        {
                            el: {
                                type: "bi.icon_button",
                                cls: "platform-search-font demo-search-button",
                                width: 35,
                                height: 30,
                                handler: function () {
                                    $("#wrapper").addClass("active");
                                }
                            }
                        }, {
                            el: {
                                type: "demo.favorite",
                                width: 35
                            }
                        }, {
                            el: {
                                type: "dec.header.message"
                            }
                        }, {
                            el: {
                                type: "dec.account"
                            }
                        }
                    ]
                }
            };
        }
    });

    BI.shortcut("demo.header", Widget);
}());
!(function () {
    var Node = BI.inherit(BI.BasicButton, {

        props: {
            baseCls: "demo-sidebar-expander",
            items: [],
            open: false
        },

        render: function () {

            var self = this, o = this.options;


            var trigger = {
                type: "demo.sidebar.node",
                text: o.text,
                height: 42,
                open: o.open,
                iconCls: o.nodeIcon,
                listeners: [
                    {
                        eventName: "EVENT_EXPAND",
                        action: function () {
                            self.showView();
                        }
                    }, {
                        eventName: "EVENT_COLLAPSE",
                        action: function () {
                            self.popuop.setVisible(false);
                        }
                    }
                ]
            };

            var items = BI.createItems(o.items, {
                type: "demo.sidebar.item",
                lgap: 30,
                height: 36
            });
            return {
                type: "bi.vertical",
                items: [
                    {
                        el: trigger
                    }, {
                        el: {
                            type: "bi.button_group",
                            cls: "demo-sidebar-expander-popup",
                            layouts: [
                                {
                                    type: "bi.vertical"
                                }
                            ],
                            ref: function (_ref) {
                                self.popuop = _ref;
                            },
                            invisible: !o.open,
                            items: items
                        }
                    }
                ]

            };
        },

        showView: function () {
            var self = this, o = this.options;
            if (BI.isEmptyArray(o.items)) {
                Dec.Utils.getWorkbenchSubDirectoryById(o.id, function (res) {
                    o.items = BI.map(res.data, function (index, item) {
                        return BI.extend({
                            type: "demo.sidebar.item",
                            lgap: 30
                        }, item);
                    });
                    self.popuop.populate(o.items);
                    self.popuop.setVisible(true);
                });
            } else {
                self.popuop.setVisible(true);
            }
        }
    });

    BI.shortcut("demo.sidebar.expander", Node);
}());
!(function () {
    var itemStorage = {};

    Dec.inactiveOthers = function (id) {
        BI.each(itemStorage, function (key, widget) {
            widget.options.id !== id && widget.setSelected(false);
        });
    };

    var Node = BI.inherit(BI.BasicButton, {

        props: {
            baseCls: "demo-sidebar-item",
            id: "",
            pId: "",
            open: false,
            height: 35,
            iconCls: "dir-panel-folder-font"
        },

        mounted: function () {
            itemStorage[this.options.id] = this;
        },

        render: function () {

            var self = this, o = this.options;


            var text = {
                type: "bi.label",
                height: o.height,
                textAlign: "left",
                text: o.text,
                title: o.text
            };

            var items = [];

            items.push({
                el: text,
                height: o.height
            });
            return {
                type: "bi.vertical_adapt",
                lgap: o.lgap,
                items: [
                    {
                        type: "bi.label",
                        textAlign: "left",
                        text: o.text,
                        title: o.text
                    }
                ]
            };
        },

        isOnce: function () {
            return true;
        },

        getValue: function () {
            return this.options.id;
        },

        doClick: function () {
            var self = this;
            Dec.inactiveOthers(this.options.id);
            var module = BI.find(BI.Constants.getConstant("dec.constant.management.navigation"), function (index, item) {
                return item.value === self.options.id;
            });
            if (module) {
                BI.Services.getService("dec.service.tabs").addItem(module);
            } else {
                BI.Services.getService("dec.service.tabs").addItem(BI.deepClone(this.options));
            }
        }
    });

    BI.shortcut("demo.sidebar.item", Node);
}());
/**
 *@desc 自定义的sidebar
 *@author dailer
 *@date 2018/12/25
 */
!(function () {
    var Widget = BI.inherit(BI.Widget, {

        props: {
            baseCls: "demo-sidebar"
        },

        /**
         *  初始化目录根节点和管理系统节点
         */
        beforeInit: function (render) {
            var self = this;
            this._initManagementModules(BI.emptyFn);
            this._initEntries(render);
        },

        render: function () {
            var items = [];
            items.push({
                el: {
                    type: "demo.sidebar.item",
                    cardType: "dec.dashboard",
                    text: "仪表板",
                    lgap: 10
                }
            });
            items.push({
                el: {
                    type: "bi.label",
                    textAlign: "left",
                    lgap: 10,
                    height: 46,
                    text: "目录"
                }
            });
            items = BI.concat(items, this.rootEntries);
            items.push({
                type: "demo.sidebar.expander",
                text: "管理系统",
                open: true,
                items: this.managementModules
            });
            return {
                type: "bi.absolute",
                items: [
                    {
                        el: {
                            type: "bi.vertical",
                            items: items
                        },
                        top: 10, left: 0, right: 0, bottom: 0
                    }
                ]

            };
        },

        _initEntries: function (cb) {
            var self = this;
            Dec.Utils.getWorkbenchSubDirectoryById(DecCst.DIRECTORY_TREE_ROOT_ID, function (res) {
                self.rootEntries = BI.map(res.data, function (index, item) {
                    return BI.extend({
                        type: "demo.sidebar.expander",
                        items: item.children
                    }, item);
                });
                cb();
            });
        },

        _initManagementModules: function (cb) {
            this.managementModules = BI.filter(BI.Constants.getConstant("dec.constant.management.navigation"), function (index, item) {
                return item.id !== "decision-management-maintenance";
            });
            cb();
        }
    });

    BI.shortcut("demo.sidebar", Widget);
}());
!(function () {
    var Node = BI.inherit(BI.NodeButton, {

        props: {
            baseCls: "demo-sidebar-node",
            id: "",
            pId: "",
            open: false,
            height: 42,
            iconCls: "dir-panel-folder-font"
        },

        render: function () {

            var self = this, o = this.options;

            var arrow = {
                type: "bi.center_adapt",
                cls: "platform-node-arrow",
                items: [
                    {
                        el: {
                            type: "bi.icon_change_button",
                            ref: function (_ref) {
                                self.arrow = _ref;
                            },
                            iconCls: o.open ? "triangle-expand-font" : "triangle-collapse-font",
                            height: 16,
                            width: 16
                        }
                    }
                ]
            };

            var icon = {
                type: "bi.center_adapt",
                height: o.height,
                cls: "platform-node-icon " + o.iconCls,
                items: [
                    {
                        type: "bi.icon",
                        height: o.height,
                        width: o.height
                    }
                ]
            };

            var text = {
                type: "bi.htape",
                height: o.height,
                items: [
                    {
                        el: {
                            type: "bi.label",
                            height: o.height,
                            textAlign: "left",
                            text: o.text
                        },
                        lgap: 5
                    }
                ]
            };

            var items = [];
            items.push({
                type: "bi.layout",
                width: 10,
                height: o.height
            });

            items.push({
                el: icon,
                height: o.height,
                width: o.height
            });

            items.push({
                el: text,
                height: o.height
            });
            items.push({
                el: arrow,
                height: o.height,
                width: 16,
                rgap: 10
            });

            return {
                type: "bi.htape",
                items: items
            };
        },

        isOnce: function () {
            return false;
        },

        getValue: function () {
            return this.options.id;
        },

        setOpened: function (v) {
            Node.superclass.setOpened.apply(this, arguments);
            this.arrow.setIcon(v ? "triangle-expand-font" : "triangle-collapse-font");
            this.fireEvent(v ? "EVENT_EXPAND" : "EVENT_COLLAPSE");
        }
    });

    BI.shortcut("demo.sidebar.node", Node);
}());